<?php

class Alg_WC_PPBF_Parenthesis extends Alg_WC_PPBF_TerminalExpression {

    protected $precedence = 6;

    public function operate(Alg_WC_PPBF_Stack $stack) {
    }

    public function getPrecedence() {
        return $this->precedence;
    }

    public function isNoOp() {
        return true;
    }

    public function isParenthesis() {
        return true;
    }

    public function isOpen() {
        return $this->value == '(';
    }

}

class Alg_WC_PPBF_Number extends Alg_WC_PPBF_TerminalExpression {

    public function operate(Alg_WC_PPBF_Stack $stack) {
        return $this->value;
    }

}

abstract class Alg_WC_PPBF_Operator extends Alg_WC_PPBF_TerminalExpression {

    protected $precedence = 0;
    protected $leftAssoc = true;

    public function getPrecedence() {
        return $this->precedence;
    }

    public function isLeftAssoc() {
        return $this->leftAssoc;
    }

    public function isOperator() {
        return true;
    }

}

class Alg_WC_PPBF_Addition extends Alg_WC_PPBF_Operator {

    protected $precedence = 4;

    public function operate(Alg_WC_PPBF_Stack $stack) {
        return $stack->pop()->operate($stack) + $stack->pop()->operate($stack);
    }

}

class Alg_WC_PPBF_Subtraction extends Alg_WC_PPBF_Operator {

    protected $precedence = 4;

    public function operate(Alg_WC_PPBF_Stack $stack) {
        $left = $stack->pop()->operate($stack);
        $right = $stack->pop()->operate($stack);
        return $right - $left;
    }

}

class Alg_WC_PPBF_Multiplication extends Alg_WC_PPBF_Operator {

    protected $precedence = 5;

    public function operate(Alg_WC_PPBF_Stack $stack) {
        return $stack->pop()->operate($stack) * $stack->pop()->operate($stack);
    }

}

class Alg_WC_PPBF_Division extends Alg_WC_PPBF_Operator {

    protected $precedence = 5;

    public function operate(Alg_WC_PPBF_Stack $stack) {
        $left = $stack->pop()->operate($stack);
        $right = $stack->pop()->operate($stack);
        return $right / $left;
    }

}

class Alg_WC_PPBF_Power extends Alg_WC_PPBF_Operator {

    protected $precedence = 5;

    public function operate(Alg_WC_PPBF_Stack $stack) {
        $left = $stack->pop()->operate($stack);
        $right = $stack->pop()->operate($stack);
        return pow($left,$right);
    }
}
